﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace AutoSecTools.Components.Net
{
    public static class HttpHeader
    {
        public const string Host = "Host";

        public const string ContentType = "Content-Type";

        public const string ContentLength = "Content-Length";

        public static Dictionary<string, List<string>> Parse(string Header)
        {
            var values = new Dictionary<string, List<string>>();

            var lines = Header.SplitLines(StringSplitOptions.None);

            if (lines.Length < 2)
                return values;

            lines = lines.Skip(1).ToArray();

            foreach (var line in lines)
            {
                var index = line.IndexOf(':');

                if (index == -1)
                    continue;

                var header = line.Split(index);

                header[1] = Regex.Replace(header[1], @"^:\s", "");

                if (!values.ContainsKey(header[0]))
                    values.Add(header[0], new List<string> { header[1] });
                else
                    values[header[0]].Add(header[1]);
            }
            
            return values;
        }

        public static string ToString(Dictionary<string, List<string>> Headers)
        {
            throw new NotImplementedException();
        }
    }
}
