﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace AutoSecTools.Components.Net
{
    public class HttpResponse : HttpMessage
    {
        public HttpResponse() { }

        public HttpResponse(string Message)
            : base(Message) { }

        public HttpResponse(string Header, string Body)
            : base(Header, Body) { }

        public int GetResponseCode()
        {
            var match = Regex.Match(Header, @"HTTP/\d\.\d\s(\d+)");

            if (!match.Success)
                return -1;
            else
                return int.Parse(match.Groups[1].Value);
        }

        public DateTime GetDate()
        {
            return DateTime.Parse(this["Date"][0]);
        }        
    }
}
