﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;

namespace AutoSecTools.Components
{
    public static class QueryString
    {
        public static Dictionary<string, string> Parse(string Query)
        {
            if (Query.Length == 0)
                return new Dictionary<string, string>();

            if (Query[0] == '?')
                Query = Query.Substring(1);

            return Query
                .Split('&')
                .Where(x => x.Contains("="))
                .Select(x => x.Split('='))
                .ToDictionary(x => x[0], x => HttpUtility.HtmlDecode(x[1]));
        }

        public static string Create(Dictionary<string, string> QueryDictionary)
        {
            return QueryDictionary
                .Select(x => x.Key + "=" + x.Value)
                .Aggregate((x, y) => x + "&" + HttpUtility.HtmlEncode(y));
        }
    }
}
