﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace AutoSecTools.Components
{
    public static class StringExtension
    {
        public static string Repeat(this string s, int Count)
        {
            return new StringBuilder().Insert(0, s, Count).ToString();
        }

        public static string Indent(this string s)
        {
            return s.Insert(0, "\t").Replace("\n", "\n\t");
        }

        public static string SubstringAtIndexOf(this string s, string Value)
        {
            return s.Substring(s.IndexOf(Value));
        }

        public static string SubstringAtIndexOf(this string s, string Value, int Offset)
        {
            return s.Substring(s.IndexOf(Value) + Offset);
        }

        public static string SubstringAtIndexOf(this string s, char Value)
        {
            return s.Substring(s.IndexOf(Value));
        }

        public static string SubstringAtIndexOf(this string s, char Value, int Offset)
        {
            return s.Substring(s.IndexOf(Value) + Offset);
        }

        public static string SubstringAtLastIndexOf(this string s, string Value)
        {
            return s.Substring(s.LastIndexOf(Value));
        }

        public static string SubstringAtLastIndexOf(this string s, string Value, int Offset)
        {
            return s.Substring(s.LastIndexOf(Value) + Offset);
        }

        public static string SubstringAtLastIndexOf(this string s, char Value)
        {
            return s.Substring(s.LastIndexOf(Value));
        }

        public static string SubstringAtLastIndexOf(this string s, char Value, int Offset)
        {
            return s.Substring(s.LastIndexOf(Value) + Offset);
        }

        public static string RemoveAtIndexOf(this string s, string Value)
        {
            return s.Remove(s.IndexOf(Value));
        }

        public static string RemoveAtIndexOf(this string s, string Value, int Offset)
        {
            return s.Remove(s.IndexOf(Value) + Offset);
        }

        public static string RemoveAtIndexOf(this string s, char Value)
        {
            return s.Remove(s.IndexOf(Value));
        }

        public static string RemoveAtIndexOf(this string s, char Value, int Offset)
        {
            return s.Remove(s.IndexOf(Value) + Offset);
        }

        public static string RemoveAtLastIndexOf(this string s, string Value)
        {
            return s.Remove(s.LastIndexOf(Value));
        }

        public static string RemoveAtLastIndexOf(this string s, string Value, int Offset)
        {
            return s.Remove(s.LastIndexOf(Value) + Offset);
        }

        public static string RemoveAtLastIndexOf(this string s, char Value)
        {
            return s.Remove(s.LastIndexOf(Value));
        }

        public static string RemoveAtLastIndexOf(this string s, char Value, int Offset)
        {
            return s.Remove(s.LastIndexOf(Value) + Offset);
        }

        public static string Slice(this string s, int StartIndex, int EndIndex)
        {
            return s.Substring(StartIndex, EndIndex - StartIndex);
        }

        public static string[] Split(this string s, int Index)
        {
            return new[] { s.Remove(Index), s.Substring(Index) };
        }

        public static string[] SplitLines(this string s, StringSplitOptions Options)
        {
            return s.Split(new[] { "\r\n" }, Options);
        }

        public static string[] SplitLines(this string s)
        {
            return SplitLines(s, StringSplitOptions.None);
        }

        public static int LeastIndexOf(this string s, params char[] Chars)
        {
            return Chars.Select(x => s.IndexOf(x)).OrderBy(x => x).First();
        }

        public static byte[] GetBytes(this string s)
        {
            var bytes = new byte[s.Length];

            for (int i = 0; i < s.Length; i++)
                bytes[i] = (byte)s[i];

            return bytes;
        }        
    }
}